using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using ClassLibrary2;

namespace WindowsApplication2
{
    public partial class TestParallaxServo : Form
    {
        public TestParallaxServo()
        {
            InitializeComponent();
        }

        private ParallaxServoController PSC = new ParallaxServoController();
 
        private void Form1_Load(object sender, EventArgs e)
        {
            // The Maximum property sets the value of the track bar when
            // the slider is all the way to the right and left.
            barServoPosition.Maximum = ParallaxServoController.ServoSteps;
            barServoPosition.Minimum = 0;

            // The TickFrequency property establishes how many positions
            // are between each tick-mark.
            barServoPosition.TickFrequency = 50;

            // The LargeChange property sets how many positions to move
            // if the bar is clicked on either side of the slider.
            barServoPosition.LargeChange =25;

            // The SmallChange property sets how many positions to move
            // if the keyboard arrows are used to move the slider.
            barServoPosition.SmallChange = 1;
 
            lblCOMBaud.Text = "" + PSC.ThePCBaudRate;
         }

        private void BarPosition_Scroll(object sender, EventArgs e)
        {
            PSC.MoveServo((byte)nudServoChannel.Value, (byte)nudRampValue.Value, (ushort)barServoPosition.Value);
            // Display the trackbar value in the text box.
            lblServoPosition.Text = "" + barServoPosition.Value;
        }

        private void btnOpen_Click(object sender, EventArgs e)
        {
            PSC.OpenConnection();
            lblCOMBaud.Text = "" + PSC.ThePCBaudRate;
        }

        private void btnClose_Click(object sender, EventArgs e)
        {
            PSC.CloseConnection();
        }

        private void btnVersion_Click(object sender, EventArgs e)
        {
            lblVersionNumber.Text = PSC.GetVersionNumber();
        }

        private void btnRequest_Click(object sender, EventArgs e)
        {
            lblRequest.Text = "" + PSC.GetServoPosition((byte)nudServoChannel.Value);
        }

        private void dudCOMPort_SelectedItemChanged(object sender, EventArgs e)
        {
            PSC.TheCOMPort = dudCOMPort.Text;
        }

        private void nudReadTimeOut_ValueChanged(object sender, EventArgs e)
        {
            PSC.TheReadTimeout = (int) nudReadTimeOut.Value;
        }

        private void nudWriteTimeOut_ValueChanged(object sender, EventArgs e)
        {
            PSC.TheWriteTimeout = (int) nudWriteTimeOut.Value;
        }

        private void rbnBaud2400_CheckedChanged(object sender, EventArgs e)
        {
            if (rbnBaud2400.Checked)
            {
                PSC.SetBaudRate(ParallaxServoController.Baud2400);
                lblCOMBaud.Text = "" + PSC.ThePCBaudRate;
            }
        }

        private void rbnBaud38K4_CheckedChanged(object sender, EventArgs e)
        {
            if (rbnBaud38K4.Checked)
            {
                PSC.SetBaudRate(ParallaxServoController.Baud38K4);
                lblCOMBaud.Text = "" + PSC.ThePCBaudRate;
            }
        }

    }
}